"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _useSelect2 = _interopRequireDefault(require("../use-select/use-select"));

var _excluded = ["invalid", "classNamePrefix", "simpleValue", "isMulti", "pluckSingleValue", "options", "loadOptions", "loadingMessage", "loadingProps", "selectVariant", "updatingMessage", "noOptionsMessage", "value", "onChange", "loadOptionsChangeCounter", "SelectComponent", "noValueUpdates", "optionsTransformer"];

var Select = function Select(_ref) {
  var invalid = _ref.invalid,
      classNamePrefix = _ref.classNamePrefix,
      simpleValue = _ref.simpleValue,
      isMulti = _ref.isMulti,
      pluckSingleValue = _ref.pluckSingleValue,
      propsOptions = _ref.options,
      loadOptions = _ref.loadOptions,
      loadingMessage = _ref.loadingMessage,
      loadingProps = _ref.loadingProps,
      selectVariant = _ref.selectVariant,
      updatingMessage = _ref.updatingMessage,
      noOptionsMessage = _ref.noOptionsMessage,
      value = _ref.value,
      onChange = _ref.onChange,
      loadOptionsChangeCounter = _ref.loadOptionsChangeCounter,
      SelectComponent = _ref.SelectComponent,
      noValueUpdates = _ref.noValueUpdates,
      optionsTransformer = _ref.optionsTransformer,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);

  var _useSelect = (0, _useSelect2["default"])({
    loadOptions: loadOptions,
    optionsTransformer: optionsTransformer,
    options: propsOptions,
    noValueUpdates: noValueUpdates,
    onChange: onChange,
    value: value,
    loadOptionsChangeCounter: loadOptionsChangeCounter,
    isSearchable: props.isSearchable,
    pluckSingleValue: pluckSingleValue,
    isMulti: isMulti,
    simpleValue: simpleValue
  }),
      state = _useSelect.state,
      selectValue = _useSelect.value,
      selectOnChange = _useSelect.onChange,
      onInputChange = _useSelect.onInputChange,
      isFetching = _useSelect.isFetching;

  var renderNoOptionsMessage = function renderNoOptionsMessage() {
    return Object.values(state.promises).some(function (value) {
      return value;
    }) ? function () {
      return updatingMessage;
    } : function () {
      return noOptionsMessage;
    };
  };

  if (state.isLoading) {
    return /*#__PURE__*/_react["default"].createElement(SelectComponent, (0, _extends2["default"])({}, props, {
      classNamePrefix: classNamePrefix,
      isDisabled: true,
      isFetching: true,
      placeholder: loadingMessage,
      options: state.options,
      onChange: function onChange() {}
    }, loadingProps, {
      noOptionsMessage: renderNoOptionsMessage()
    }, state.originalOptions && {
      originalOptions: state.originalOptions
    }));
  }

  return /*#__PURE__*/_react["default"].createElement(SelectComponent, (0, _extends2["default"])({
    className: (0, _clsx["default"])(classNamePrefix, {
      'has-error': invalid
    })
  }, props, {
    isDisabled: props.isDisabled || props.isReadOnly,
    options: state.options,
    classNamePrefix: classNamePrefix,
    isMulti: isMulti,
    value: selectValue,
    onChange: selectOnChange,
    onInputChange: onInputChange,
    isFetching: isFetching,
    noOptionsMessage: renderNoOptionsMessage(),
    hideSelectedOptions: false,
    closeMenuOnSelect: !isMulti
  }, state.originalOptions && {
    originalOptions: state.originalOptions
  }));
};

Select.propTypes = {
  options: _propTypes["default"].array,
  onChange: _propTypes["default"].func,
  classNamePrefix: _propTypes["default"].string,
  invalid: _propTypes["default"].bool,
  simpleValue: _propTypes["default"].bool,
  isMulti: _propTypes["default"].bool,
  pluckSingleValue: _propTypes["default"].bool,
  value: _propTypes["default"].any,
  placeholder: _propTypes["default"].string,
  loadOptionsChangeCounter: _propTypes["default"].number,
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  loadOptions: _propTypes["default"].func,
  loadingMessage: _propTypes["default"].node,
  loadingProps: _propTypes["default"].object,
  selectVariant: _propTypes["default"].string,
  updatingMessage: _propTypes["default"].node,
  noOptionsMessage: _propTypes["default"].node,
  isSearchable: _propTypes["default"].bool,
  SelectComponent: _propTypes["default"].elementType.isRequired,
  noValueUpdates: _propTypes["default"].bool,
  optionsTransformer: _propTypes["default"].func
};
Select.defaultProps = {
  options: [],
  invalid: false,
  simpleValue: true,
  pluckSingleValue: true,
  placeholder: 'Choose...',
  isSearchable: false,
  isClearable: false
};
var _default = Select;
exports["default"] = _default;